#ifndef MAINWINDOW_H_INC
#define MAINWINDOW_H_INC

#include "SmartWin.h"
#include "canvasclasses.h"
#include "basictypes.h"
#include <list>
#include "drawobj.h"

class MainWindowClass : public SmartWin::WidgetFactory< SmartWin::WidgetWindow, MainWindowClass>
{
public:
   enum CommandEnum
   {
      LoadCmd,
      SaveCmd,
      AboutCmd,
      DrawLineCmd,
      DrawRectangleCmd,
      DrawRedCmd,
      DrawBlueCmd,
      DrawGreenCmd
   };

private:
   WidgetMenuPtr Menu;
   WidgetToolbar *Toolbar;
	WidgetStatusBarSections *Statusbar;
   void LoadFile();
   void SaveFile();
   void About();
   void MenuClicked(WidgetMenu *aMenu, unsigned aItem);
   void OnPaint(SmartWin::PaintCanvas &aPaintCanvas);
   void OnLeftMouseDown(const SmartWin::MouseEventResult &aEventResult);
   void OnLeftMouseUp(const SmartWin::MouseEventResult &aEventResult);
   void OnMouseMove(const SmartWin::MouseEventResult &aEventResult);
   void ToolbarClicked(WidgetToolbar *aItem, unsigned int aId);
   void IsResized(const SmartWin::WindowSizedEventResult &sz);

   CommandEnum CurrentObject;
   COLORREF Color;
   bool WasDown;
   std::list<ObjectBaseClass *>ObjectList;
   unsigned int ToolbarHeight;
public:
   MainWindowClass();
   ~MainWindowClass();
};

template <typename T>
std::string ToString(T aValue)
{
   std::stringstream ss;
   ss << aValue;
   return ss.str();
}

#endif
