#include "SmartWin.h"
#include "drawobj.h"
#include "mainwindow.h"

void LineClass::Write(std::ostream &os)
{
   os << MainWindowClass::DrawLineCmd << std::endl;
   os << Start << std::endl;
   os << End << std::endl;
   os << Color << std::endl;
}

bool LineClass::Read(std::istream &is)
{
   is >> Start;
   is >> End;
   is >> Color;
   return is;
}

void RectangleClass::Write(std::ostream &os)
{
   os << MainWindowClass::DrawRectangleCmd << std::endl;
   os << Start << std::endl;
   os << End << std::endl;
   os << Color << std::endl;
}

bool RectangleClass::Read(std::istream &is)
{
   is >> Start;
   is >> End;
   is >> Color;
   return is;
}

void RectangleClass::Draw(SmartWin::Canvas &aCanvas, bool aMoving)
{
   SmartWin::HdcModeSetter Mode(aCanvas, aMoving ? R2_NOTXORPEN : R2_COPYPEN);
   SmartWin::Pen pen(aCanvas, Color);
   aCanvas.MoveTo(Start);
   aCanvas.LineTo(End.x, Start.y);
   aCanvas.LineTo(End);
   aCanvas.LineTo(Start.x, End.y);
   aCanvas.LineTo(Start);
}
